From ec535913c92ce18ee2a8fee916b27bb009754383 Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Dec 12 2017 16:57:41 +0000
Subject: [PATCH 34/51] check types of content components' metadata


---

diff --git a/src/_fedmod/modulemd_linter.py b/src/_fedmod/modulemd_linter.py
index 6e28eb0..5617e20 100644
--- a/src/_fedmod/modulemd_linter.py
+++ b/src/_fedmod/modulemd_linter.py
@@ -106,8 +106,17 @@ class ModuleMDLinter(object):
 
     yaml_scalar_types = (str, int, float)
 
-    recognized_rpm_keys = {'rationale', 'buildorder', 'repository', 'ref',
-                           'cache', 'arches', 'multilib'}
+    components_keys_types = {
+        'rationale': str,
+        'buildorder': int,
+        'repository': str,
+        'ref': str,
+        'cache': str,
+        'arches': [str],
+        'multilib': [str],
+    }
+
+    recognized_rpm_keys = set(components_keys_types)
 
     recognized_module_keys = {'rationale', 'buildorder', 'repository', 'ref'}
 
@@ -658,6 +667,38 @@ class ModuleMDLinter(object):
                     self.check('rationale' in subblock)
                     self.check_is_scalar(subblock['rationale'])
 
+    @error
+    @guidelines_link('#Module_components')
+    @detail("Illegal type of component key(s): 'buildorder' must be an"
+            " integer, 'arches' and 'multilib' a list of strings and all"
+            " others strings.")
+    @prerequisite('components_subblocks_dict')
+    def lint_components_blocks_keys_types(self):
+        """Modules MAY, and most modules do contain a components block defining
+        the module's content."""
+        if 'components' not in self.mmd:
+            return
+
+        for block in self.mmd['components'].values():
+            for comp_md in block.values():
+                for k, v in comp_md.items():
+                    t = self.components_keys_types.get(k)
+                    if not t:
+                        # unknown key
+                        continue
+
+                    if isinstance(t, list):
+                        self.check_is_list(v)
+                        t = t[0]
+                    else:
+                        v = [v]
+
+                    if issubclass(t, str):
+                        t = self.yaml_scalar_types
+
+                    for value in v:
+                        self.check(isinstance(value, t))
+
     @warning
     @guidelines_link('#RPM_content')
     @detail("Recognized keys are: {}".format(

